#
# HaloDemoTrainer.py
#
# Created by nil
# Copyright (c) 2009. All rights reserved.

from VirtualMemory import *
from Debug import *
import math

WINDOW_TITLE = "Everyone vs I"
DESCRIPTION = "Everyone vs the host. Bring it on! Make sure to play this on CTF."
EXECUTION_TIME_INTERVAL = 1.0

#Halo Demo constants
FIRST_STATIC_PLAYER_ADDRESS = 0x4BD7AFD0
STATIC_PLAYER_SIZE = 0x200
TEAM_INDEX_OFFSET = 0x1E
PLAYER_OBJECT_ID_OFFSET = 0x32
INVALID_PLAYER_OBJECT_ID = 0xFFFF

FIRST_TABLE_OBJECT_ADDRESS = 0x4BB206EC
OBJECT_TABLE_SIZE = 12
OFFSET_TO_HALO_OBJECT_POINTER = 0x8

OFFSET_TO_PLAYER_X_COORDINATE = 0x5C

MAX_HALO_PLAYERS = 16
READ_TEAM_INDEX = 0
BLUE_TEAM_INDEX = 1

def execute(timeElapsed):
	for playerIndex in range(1, MAX_HALO_PLAYERS):
		playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
		if playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
			#get the team index of the living player
			teamIndex = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			if teamIndex == READ_TEAM_INDEX:
				writeToLog("Killing " + readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE * playerIndex, NATIVE_ENDIAN_BYTE_ORDER))
				#Die, die!
				playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
				#move the player's x coordinate to some arbitrary value that will make him die..
				writeFloat(playerAddress + OFFSET_TO_PLAYER_X_COORDINATE, 1000.0)
				#make his team number "normal" :)
				writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex, BLUE_TEAM_INDEX)
		
def finish(timeElapsed, forcedShutDown):
	pass